#include "OBJECTS.h"

extern unsigned int year,day,month,weekday,hours,seconds,minutes;
extern char SetSec,SetMin,SetHr,SetWeek,SetDay,SetMn,SetYear;

void RTCC_Init(){

  asm{
      movlb 0x0F
      bcf INTCON, GIE
      movlw 0x55
      movwf EECON2
      movlw 0xAA
      movwf EECON2
      bsf RTCCFG,RTCWREN
  }
  
   PADCFG1.RTSECSEL1 = 1;
   PADCFG1.RTSECSEL0 = 0;
   
   RTCCAL = 0x01;                                                               //see datasheet page n.230
   
   RTCCFG = 0x23;                                                               //set register for new data insertion
   RTCVALL = 0x22;                                                              //set year
   
   RTCCFG = 0x22;                                                               //set register for new data insertion
   RTCVALL = 0x17;                                                              //set day
   RTCVALH = 0x05;                                                              //set month
   RTCVALL = 0x20;                                                              //set hour
   RTCVALH = 0x02;                                                              //set weekday
   RTCVALL = 0x00;                                                              //set seconds
   RTCVALH = 0x34;                                                              //set minutes
   RTCCFG.RTCEN = 1;                                                            //RTCC run
   Delay08s();
   
  asm{
      movlb 0x0F
      bcf INTCON, GIE
      movlw 0x55
      movwf EECON2
      movlw 0xAA
      movwf EECON2
      bcf RTCCFG,RTCWREN
  }
}

void RTCC_Program() {
  asm{
      movlb 0x0F
      bcf INTCON, GIE
      movlw 0x55
      movwf EECON2
      movlw 0xAA
      movwf EECON2
      bsf RTCCFG,RTCWREN
  }

 PADCFG1.RTSECSEL1 = 1;
 PADCFG1.RTSECSEL0 = 0;

 RTCCAL = 0x01;                                                                 //see datasheet page n.230

 RTCCFG = 0x23;                                                                 //set register for new data insertion
 RTCVALL = SetYear;                                                             //set year

 RTCCFG = 0x22;                                                                 //set register for new data insertion
 RTCVALL = SetDay;                                                              //set day
 RTCVALH = SetMn;                                                               //set month
 RTCVALL = SetHr;                                                               //set hour
 RTCVALH = SetWeek;                                                             //set weekday
 RTCVALL = SetSec;                                                              //set seconds
 RTCVALH = SetMin;                                                              //set minutes
 RTCCFG.RTCEN = 1;                                                              //RTCC run
 Delay08s();

  asm{
      movlb 0x0F
      bcf INTCON, GIE
      movlw 0x55
      movwf EECON2
      movlw 0xAA
      movwf EECON2
      bcf RTCCFG,RTCWREN
  }
  
 RC1IE_bit = 1;                                                                 //enable interrupts for new uart command
 RC1IF_bit = 0;
 PEIE_bit  = 1;
 GIE_bit   = 1;
}

void Read_Internal_RTCC() {

   RTCCFG = 0x03;                                                               //set register pointer for new read
   year = RTCVALL;                                                              //read year
   RTCCFG = 0x02;                                                               //set register pointer for new read
   day = RTCVALL;                                                               //read day
   month = RTCVALH;                                                             //read month
   RTCCFG = 0x1;                                                                //set pointer to for new read
   hours = RTCVALL;                                                             //read hours
   weekday = RTCVALH;                                                           //read weekday
   RTCCFG = 0x00;                                                               //set pointer to new read
   seconds = RTCVALL;                                                           //read seconds
   minutes = RTCVALH;                                                           //read minutes

   hours = (((hours & 0x30)   >> 4) * 10) + (hours & 0x0F);
   minutes = (((minutes & 0x70) >> 4) * 10) + (minutes & 0x0F);
   seconds = (((seconds & 0x70) >> 4) * 10) + (seconds & 0x0F);
   year = (((year & 0xF0)    >> 4) * 10) + (year & 0x0F);
   month = (((month & 0x10)   >> 4) * 10) + (month & 0x0F);
   day = (((day & 0x30)     >> 4) * 10) + (day & 0x0F);
}